Panda3D

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
AuxBitplaneAttrib Class Reference

Modern frame buffers can have 'aux' bitplanes, which are additional bitplanes above and beyond the standard depth and color. More...

`#include "auxBitplaneAttrib.h"`

Inheritance diagram for AuxBitplaneAttrib:

## Public Types
enum | AuxBitplaneOutput { ABO_glow = 1 , ABO_aux_normal = 2 , ABO_aux_glow = 4 }
Public Types inherited from RenderAttrib
enum | PandaCompareFunc { M_none =0 , M_never , M_less , M_equal , M_less_equal , M_greater , M_not_equal , M_greater_equal , M_always }
enum | TexGenMode { M_off , M_eye_sphere_map , M_world_cube_map , M_eye_cube_map , M_world_normal , M_eye_normal , M_world_position , M_unused , M_eye_position , M_point_sprite , M_unused2 , M_constant }

## Public Member Functions
virtual TypeHandle | force_init_type ()
int | get_outputs () const
virtual int | get_slot () const
virtual TypeHandle | get_type () const
virtual void | output (std::ostream &out) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from RenderAttrib
| RenderAttrib (const RenderAttrib &copy)=delete
virtual | ~RenderAttrib ()
| The destructor is responsible for removing the RenderAttrib from the global set if it is there.
int | compare_to (const RenderAttrib &other) const
| CPT (RenderAttrib) compose(const RenderAttrib *other) const
| CPT (RenderAttrib) get_unique() const
| CPT (RenderAttrib) invert_compose(const RenderAttrib *other) const
virtual bool | cull_callback (CullTraverser *trav, const CullTraverserData &data) const
| If has_cull_callback() returns true, this function will be called during the cull traversal to perform any additional operations that should be performed at cull time.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
size_t | get_hash () const
virtual bool | has_cull_callback () const
| Should be overridden by derived classes to return true if cull_callback() has been defined.
virtual bool | lower_attrib_can_override () const
| Intended to be overridden by derived RenderAttrib types to specify how two consecutive RenderAttrib objects of the same type interact.
RenderAttrib & | operator= (const RenderAttrib &copy)=delete
virtual bool | unref () const final
| This method overrides ReferenceCount::unref() to clear the pointer from the global object pool when its reference count goes to zero.
virtual void | write (std::ostream &out, int indent_level) const
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static int | get_class_slot ()
static TypeHandle | get_class_type ()
static void | init_type ()
static ConstPointerTo< RenderAttrib > | make ()
| Constructs a default AuxBitplaneAttrib object.
static ConstPointerTo< RenderAttrib > | make (int outputs)
| Constructs a specified AuxBitplaneAttrib object.
static ConstPointerTo< RenderAttrib > | make_default ()
| Returns a RenderAttrib that corresponds to whatever the standard default properties for render attributes of this type ought to be.
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type AuxBitplaneAttrib.
Static Public Member Functions inherited from RenderAttrib
static TypedWritable * | change_this (TypedWritable *old_ptr, BamReader *manager)
| Called immediately after complete_pointers(), this gives the object a chance to adjust its own pointer if desired.
static int | garbage_collect ()
| Performs a garbage-collection cycle.
static TypeHandle | get_class_type ()
static int | get_num_attribs ()
| Returns the total number of unique RenderAttrib objects allocated in the world.
static void | init_attribs ()
| Make sure the global _attribs map is allocated.
static void | init_type ()
static void | list_attribs (std::ostream &out)
| Lists all of the RenderAttribs in the cache to the output stream, one per line.
static int | register_slot (TypeHandle type_handle, int sort, RenderAttrib *default_attrib)
| Adds the indicated TypeHandle to the registry, if it is not there already, and returns a unique slot number.
static bool | validate_attribs ()
| Ensures that the cache is still stored in sorted order.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_class_slot
| get_outputs
| Returns the AuxBitplaneAttrib output bits.
Public Attributes inherited from RenderAttrib
| get_slot
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

Modern frame buffers can have 'aux' bitplanes, which are additional bitplanes above and beyond the standard depth and color.

This attrib controls what gets rendered into those additional bitplanes. It can also affect what goes into the alpha channel of the primary color buffer.

ABO_glow: copy the glow map into the alpha channel of the primary frame buffer. If there is no glow map, set it to zero. Caveat: it is not possible to write glow or depth values to the framebuffer alpha channel at the same time as using alpha blending or alpha testing. Any attempt to use transparency, blending, or alpha testing will cause this flag to be overridden.

ABO_aux_normal: put the camera-space normal into the into the R,G components of the first auxiliary bitplane.

ABO_aux_modelz: put the clip-space Z coordinate of the center of the model (after perspective divide) into the B channel of the first auxiliary bitplane.

ABO_aux_glow: put a copy of the glow map into the alpha channel of the first auxiliary bitplane. If there is no glow map, set it to zero.

AuxBitplaneAttrib is relevant only when shader generation is enabled. Otherwise, it has no effect.

Definition at line 49 of file auxBitplaneAttrib.h.

## Member Enumeration Documentation

## ◆ AuxBitplaneOutput

enum AuxBitplaneAttrib::AuxBitplaneOutput

Definition at line 54 of file auxBitplaneAttrib.h.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle AuxBitplaneAttrib::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from RenderAttrib.

Definition at line 111 of file auxBitplaneAttrib.h.

## ◆ get_class_slot()

static int AuxBitplaneAttrib::get_class_slot | ( |  | ) |
| inline static

Definition at line 82 of file auxBitplaneAttrib.h.

## ◆ get_class_type()

static TypeHandle AuxBitplaneAttrib::get_class_type | ( |  | ) |
| inline static

Definition at line 99 of file auxBitplaneAttrib.h.

## ◆ get_slot()

virtual int AuxBitplaneAttrib::get_slot | ( |  | ) | const
| inline virtual

Implements RenderAttrib.

Definition at line 85 of file auxBitplaneAttrib.h.

## ◆ get_type()

virtual TypeHandle AuxBitplaneAttrib::get_type | ( |  | ) | const
| inline virtual

Reimplemented from RenderAttrib.

Definition at line 108 of file auxBitplaneAttrib.h.

## ◆ init_type()

static void AuxBitplaneAttrib::init_type | ( |  | ) |
| inline static

Definition at line 102 of file auxBitplaneAttrib.h.

## ◆ make() [1/2]

ConstPointerTo< RenderAttrib > AuxBitplaneAttrib::make | ( |  | ) |
| static

Constructs a default AuxBitplaneAttrib object.

Definition at line 29 of file auxBitplaneAttrib.cxx.

## ◆ make() [2/2]

ConstPointerTo< RenderAttrib > AuxBitplaneAttrib::make | ( | int | outputs | ) |
| static

Constructs a specified AuxBitplaneAttrib object.

Definition at line 41 of file auxBitplaneAttrib.cxx.

## ◆ make_default()

ConstPointerTo< RenderAttrib > AuxBitplaneAttrib::make_default | ( |  | ) |
| static

Returns a RenderAttrib that corresponds to whatever the standard default properties for render attributes of this type ought to be.

Definition at line 51 of file auxBitplaneAttrib.cxx.

## ◆ output()

void AuxBitplaneAttrib::output | ( | std::ostream & | out | ) | const
| virtual

Reimplemented from RenderAttrib.

Definition at line 59 of file auxBitplaneAttrib.cxx.

## ◆ register_with_read_factory()

void AuxBitplaneAttrib::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type AuxBitplaneAttrib.

Definition at line 103 of file auxBitplaneAttrib.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

Referenced by init_libpgraph().

## ◆ write_datagram()

void AuxBitplaneAttrib::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from RenderAttrib.

Definition at line 112 of file auxBitplaneAttrib.cxx.

References Datagram::add_int32(), and RenderAttrib::write_datagram().

## Member Data Documentation

## ◆ get_class_slot

AuxBitplaneAttrib::get_class_slot

Definition at line 88 of file auxBitplaneAttrib.h.

## ◆ get_outputs

int AuxBitplaneAttrib::get_outputs
| inline

Returns the AuxBitplaneAttrib output bits.

Definition at line 67 of file auxBitplaneAttrib.h.

The documentation for this class was generated from the following files:

- panda/src/pgraph/auxBitplaneAttrib.h
- panda/src/pgraph/auxBitplaneAttrib.cxx
- panda/src/pgraph/auxBitplaneAttrib.I